---
title: "FreeBSD/alpha 5.4-RELEASE Release Notes"
sidenav: download
---

++++


<h3 class="CORPAUTHOR">The FreeBSD Project</h3>

<p class="COPYRIGHT">Copyright &copy; 2000, 2001, 2002, 2003, 2004, 2005 The FreeBSD
Documentation Project</p>

<p class="PUBDATE">$FreeBSD: src/release/doc/en_US.ISO8859-1/relnotes/common/new.sgml,v
1.761.2.41.2.9 2005/05/05 17:49:08 hrs Exp $<br />
</p>

<div class="LEGALNOTICE"><a id="TRADEMARKS" name="TRADEMARKS"></a>
<p>FreeBSD is a registered trademark of the FreeBSD Foundation.</p>

<p>IBM, AIX, EtherJet, Netfinity, OS/2, PowerPC, PS/2, S/390, and ThinkPad are trademarks
of International Business Machines Corporation in the United States, other countries, or
both.</p>

<p>IEEE, POSIX, and 802 are registered trademarks of Institute of Electrical and
Electronics Engineers, Inc. in the United States.</p>

<p>Intel, Celeron, EtherExpress, i386, i486, Itanium, Pentium, and Xeon are trademarks or
registered trademarks of Intel Corporation or its subsidiaries in the United States and
other countries.</p>

<p>Sparc, Sparc64, SPARCEngine, and UltraSPARC are trademarks of SPARC International, Inc
in the United States and other countries. Products bearing SPARC trademarks are based
upon architecture developed by Sun Microsystems, Inc.</p>

<p>Many of the designations used by manufacturers and sellers to distinguish their
products are claimed as trademarks. Where those designations appear in this document, and
the FreeBSD Project was aware of the trademark claim, the designations have been followed
by the ``&trade;'' or the ``&reg;'' symbol.</p>
</div>

<div>
<div class="ABSTRACT"><a id="AEN23" name="AEN23"></a>
<p>The release notes for FreeBSD 5.4-RELEASE contain a summary of the changes made to the
FreeBSD base system since 5.3-RELEASE. This document lists applicable security advisories
that were issued since the last release, as well as significant changes to the FreeBSD
kernel and userland. Some brief remarks on upgrading are also presented.</p>
</div>
</div>

<hr />
</div>

<div class="TOC">
<dl>
<dt><b>Table of Contents</b></dt>

<dt>1 <a href="#INTRO">Introduction</a></dt>

<dt>2 <a href="#NEW">What's New</a></dt>

<dd>
<dl>
<dt>2.1 <a href="#SECURITY">Security Advisories</a></dt>

<dt>2.2 <a href="#KERNEL">Kernel Changes</a></dt>

<dd>
<dl>
<dt>2.2.1 <a href="#BOOT">Boot Loader Changes</a></dt>

<dt>2.2.2 <a href="#PROC">Hardware Support</a></dt>

<dt>2.2.3 <a href="#NET-PROTO">Network Protocols</a></dt>

<dt>2.2.4 <a href="#DISKS">Disks and Storage</a></dt>

<dt>2.2.5 <a href="#FS">File Systems</a></dt>

<dt>2.2.6 <a href="#AEN292">Contributed Software</a></dt>
</dl>
</dd>

<dt>2.3 <a href="#USERLAND">Userland Changes</a></dt>

<dd>
<dl>
<dt>2.3.1 <a href="#RC-SCRIPTS"><tt class="FILENAME">/etc/rc.d</tt> Scripts</a></dt>
</dl>
</dd>

<dt>2.4 <a href="#CONTRIB">Contributed Software</a></dt>

<dt>2.5 <a href="#PORTS">Ports/Packages Collection Infrastructure</a></dt>

<dt>2.6 <a href="#RELENG">Release Engineering and Integration</a></dt>

<dt>2.7 <a href="#DOC">Documentation</a></dt>
</dl>
</dd>

<dt>3 <a href="#UPGRADE">Upgrading from previous releases of FreeBSD</a></dt>
</dl>
</div>

<div class="SECT1">
<h2 class="SECT1"><a id="INTRO" name="INTRO">1 Introduction</a></h2>

<p>This document contains the release notes for FreeBSD 5.4-RELEASE on the Alpha/AXP
hardware platform. It describes recently added, changed, or deleted features of FreeBSD.
It also provides some notes on upgrading from previous versions of FreeBSD.</p>

<p>This distribution of FreeBSD 5.4-RELEASE is a release distribution. It can be found at
<a href="ftp://ftp.FreeBSD.org/" target="_top">ftp://ftp.FreeBSD.org/</a> or any of its
mirrors. More information on obtaining this (or other) release distributions of FreeBSD
can be found in the <a
href="http://www.FreeBSD.org/doc/en_US.ISO8859-1/books/handbook/mirrors.html"
target="_top">``Obtaining FreeBSD'' appendix</a> to the <a
href="http://www.FreeBSD.org/doc/en_US.ISO8859-1/books/handbook/" target="_top">FreeBSD
Handbook</a>.</p>

<p>All users are encouraged to consult the release errata before installing FreeBSD. The
errata document is updated with ``late-breaking'' information discovered late in the
release cycle or after the release. Typically, it contains information on known bugs,
security advisories, and corrections to documentation. An up-to-date copy of the errata
for FreeBSD 5.4-RELEASE can be found on the FreeBSD Web site.</p>
</div>

<div class="SECT1">
<hr />
<h2 class="SECT1"><a id="NEW" name="NEW">2 What's New</a></h2>

<p>This section describes the most user-visible new or changed features in FreeBSD since
5.3-RELEASE. In general, changes described here are unique to the 5-STABLE branch unless
specifically marked as [MERGED] features.</p>

<p>Typical release note items document recent security advisories issued after
5.3-RELEASE, new drivers or hardware support, new commands or options, major bug fixes,
or contributed software upgrades. They may also list changes to major ports/packages or
release engineering practices. Clearly the release notes cannot list every single change
made to FreeBSD between releases; this document focuses primarily on security advisories,
user-visible changes, and major architectural improvements.</p>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="SECURITY" name="SECURITY">2.1 Security Advisories</a></h3>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fetch&sektion=1&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fetch</span>(1)</span></a>
utility, which allows a malicious HTTP server to cause arbitrary portions of the client's
memory to be overwritten, has been fixed. For more information, see security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-04:16.fetch.asc"
target="_top">FreeBSD-SA-04:16.fetch</a>.</p>

<p>A bug in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=procfs&sektion=5&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">procfs</span>(5)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=linprocfs&sektion=5&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">linprocfs</span>(5)</span></a>
which could allow a malicious local user to read parts of kernel memory or perform a
local denial of service attack by causing a system panic, has been fixed. For more
information, see security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-04:17.procfs.asc"
target="_top">FreeBSD-SA-04:17.procfs</a>.</p>

<p>Two buffer overflows in the TELNET client program have been corrected. They could have
allowed a malicious TELNET server or an active network attacker to cause <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=telnet&sektion=1&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">telnet</span>(1)</span></a> to
execute arbitrary code with the privileges of the user running it. More information can
be found in security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-05:01.telnet.asc"
target="_top">FreeBSD-SA-05:01.telnet</a>.</p>

<p>A information disclosure vulnerability in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sendfile&sektion=2&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sendfile</span>(2)</span></a>
system call, which could permit it to transmit random parts of kernel memory, has been
fixed. More details are in security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-05:02.sendfile.asc"
target="_top">FreeBSD-SA-05:02.sendfile</a>.</p>

<p>An information leak vulnerability in the <tt class="LITERAL">SIOCGIFCONF</tt> <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ioctl&sektion=2&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ioctl</span>(2)</span></a>, which
leaked 12 bytes of kernel memory, has been fixed. More details are in security advisory
<a href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-05:04.ifconf.asc"
target="_top">FreeBSD-SA-05:04.ifconf</a>.</p>

<p>Several programming errors in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cvs&sektion=1&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cvs</span>(1)</span></a>, which
could potentially cause arbitrary code to be executed on CVS servers, have been
corrected. Further information can be found in security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-05:05.cvs.asc"
target="_top">FreeBSD-SA-05:05.cvs</a>.</p>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="KERNEL" name="KERNEL">2.2 Kernel Changes</a></h3>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jail&sektion=8&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">jail</span>(8)</span></a> feature
now supports a new sysctl <code class="VARNAME">security.jail.chflags_allowed</code>,
which controls the behavior of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=chflags&sektion=1&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">chflags</span>(1)</span></a>
within a jail. If set to <tt class="LITERAL">0</tt> (the default), then a jailed <tt
class="USERNAME">root</tt> user is treated as an unprivileged user; if set to <tt
class="LITERAL">1</tt>, then a jailed root user is treated the same as an unjailed <tt
class="USERNAME">root</tt> user.</p>

<p>The loader tunable <code class="VARNAME">debug.mpsafevm</code> has been enabled by
default.</p>

<p>A number of bugs have been fixed in the ULE scheduler.</p>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="BOOT" name="BOOT">2.2.1 Boot Loader Changes</a></h4>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="PROC" name="PROC">2.2.2 Hardware Support</a></h4>

<p>A framework for flexible processor speed control has been added. It provides methods
for various drivers to control CPU power utilization by adjusting the processor speed.
More details can be found in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cpufreq&sektion=4&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cpufreq</span>(4)</span></a>
manual page.</p>

<p>The pcii driver has been added to support GPIB-PCIIA IEEE-488 cards.</p>

<div class="SECT4">
<hr />
<h5 class="SECT4"><a id="MM" name="MM">2.2.2.1 Multimedia Support</a></h5>
</div>

<div class="SECT4">
<hr />
<h5 class="SECT4"><a id="NET-IF" name="NET-IF">2.2.2.2 Network Interface Support</a></h5>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cdce&sektion=4&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cdce</span>(4)</span></a> USB
Communication Device Class Ethernet driver has been added.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cp&sektion=4&manpath=FreeBSD+5.4-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">cp</span>(4)</span></a> driver is now
MPSAFE.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ctau&sektion=4&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ctau</span>(4)</span></a> driver
is now MPSAFE.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cx&sektion=4&manpath=FreeBSD+5.4-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">cx</span>(4)</span></a> driver is now
MPSAFE.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ed&sektion=4&manpath=FreeBSD+5.4-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">ed</span>(4)</span></a> driver now
supports the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=altq&sektion=4&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">altq</span>(4)</span></a>
framework.</p>

<p>In the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=em&sektion=4&manpath=FreeBSD+5.4-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">em</span>(4)</span></a> driver,
hardware support for VLAN tagging is now disabled by default due to some interactions
between this feature and promiscuous mode.</p>

<p>Ethernet flow control is now disabled by default in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fxp&sektion=4&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fxp</span>(4)</span></a> driver,
to prevent problems with a system panics or is left in the kernel debugger.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hme&sektion=4&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hme</span>(4)</span></a> driver is
now MPSAFE.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=re&sektion=4&manpath=FreeBSD+5.4-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">re</span>(4)</span></a> driver now
supports the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=altq&sektion=4&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">altq</span>(4)</span></a>
framework.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sf&sektion=4&manpath=FreeBSD+5.4-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">sf</span>(4)</span></a> driver now has
support for device polling and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=altq&sektion=4&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">altq</span>(4)</span></a>.</p>

<p>Several programming errors in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sk&sektion=4&manpath=FreeBSD+5.4-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">sk</span>(4)</span></a> driver have
been corrected. These bugs were particular to SMP systems, and could cause panics, page
faults, aborted SSH connections, or corrupted file transfers. More details can be found
in errata note <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/ERRATA/notices/FreeBSD-EN-05:02.sk.asc"
target="_top">FreeBSD-EN-05:02.sk</a>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sk&sektion=4&manpath=FreeBSD+5.4-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">sk</span>(4)</span></a> driver now has
support for <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=altq&sektion=4&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">altq</span>(4)</span></a>. This
driver also now supports jumbo frames on Yukon-based interfaces.</p>
</div>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="NET-PROTO" name="NET-PROTO">2.2.3 Network Protocols</a></h4>

<p>The MTU feedback in IPv6 has been disabled when the sender writes data that must be
fragmented.</p>

<p>The Common Address Redundancy Protocol (CARP) has been implemented. CARP comes from
OpenBSD and allows multiple hosts to share an IP address, providing high availability and
load balancing. For more information, see the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=carp&sektion=4&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">carp</span>(4)</span></a> manual
page.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&sektion=4&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(4)</span></a> system
can work with <code class="VARNAME">debug.mpsafenet</code>=<tt class="LITERAL">1</tt>
(this tunable is <tt class="LITERAL">1</tt> by default) when the <tt
class="LITERAL">gid</tt>, <tt class="LITERAL">jail</tt>, and/or <tt
class="LITERAL">uid</tt> rule options are used.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&sektion=8&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(8)</span></a> <tt
class="LITERAL">ipfw fwd</tt> rule now supports the full packet destination manipulation
when the kernel option <tt class="LITERAL">options IPFIREWALL_FORWARD_EXTENDED</tt> is
specified in addition to <tt class="LITERAL">options IPFIREWALL_FORWARD</tt>. This kernel
option disables all restrictions to ensure proper behavior for locally generated packets
and allows redirection of packets destined to locally configured IP addresses. Note that
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&sektion=8&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(8)</span></a> rules
have to be carefully crafted to make sure that things like PMTU discovery do not
break.</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipnat&sektion=8&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipnat</span>(8)</span></a> now
allows redirect rules to work for non-TCP/UDP packets.</p>

<p>Ongoing work is reducing the use of the Giant lock by the network protocol stack and
improving the locking strategies.</p>

<p>A new <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ng_netflow&sektion=4&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ng_netflow</span>(4)</span></a>
NetGraph node allows a router running FreeBSD to do NetFlow version 5 exports.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sppp&sektion=4&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sppp</span>(4)</span></a> driver
now includes Frame Relay support.</p>

<p>A bug in TCP that sometimes caused RST packets to be ignored if the receive window was
zero bytes has been fixed.</p>

<p>Several bugs in the TCP SACK implementation have been fixed.</p>

<p>The KAME IPv4 IPsec implementation integrated in FreeBSD now supports TCP-MD5.</p>

<p>Random ephemeral port number allocation has led to some problems with port reuse at
high connection rates. This feature is now disabled during periods of high connection
rates; whenever new connections are created faster than <code
class="VARNAME">net.inet.ip.portrange.randomcps</code> per second, port number
randomization is disabled for the next <code
class="VARNAME">net.inet.ip.portrange.randomtime</code> seconds. The default values for
these two sysctl variables are <tt class="LITERAL">10</tt> and <tt
class="LITERAL">45</tt>, respectively.</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="DISKS" name="DISKS">2.2.4 Disks and Storage</a></h4>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=amr&sektion=4&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">amr</span>(4)</span></a> driver is
now safe for use on systems using <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pae&sektion=4&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pae</span>(4)</span></a>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hptmv&sektion=4&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hptmv</span>(4)</span></a> driver,
which supports the HighPoint RocketRAID 182x series, has been added.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ips&sektion=4&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ips</span>(4)</span></a> driver
now support kernel crash dumps on some modern ServeRAID models.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=matcd&sektion=4&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">matcd</span>(4)</span></a> driver
has been removed.</p>

<p>The SHSEC GEOM class has been added. It provides for the sharing of a secret between
multiple GEOM providers. All of these providers must be present in order to reveal the
secret. This feature is controlled by the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gshsec&sektion=8&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gshsec</span>(8)</span></a>
utility.</p>

<p>Information about newly-mounted cd9660 file systems (such as the presence of RockRidge
extensions) is now only printed if the kernel was booted in verbose mode. This change was
made to reduce the amount of (generally unnecessary) kernel log messages.</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="FS" name="FS">2.2.5 File Systems</a></h4>

<p>Recomputing the summary information for ``dirty'' UFS and UFS2 file systems is no
longer done at mount time, but is now done by background <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fsck&sektion=8&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fsck</span>(8)</span></a>. This
change improves the startup speed when mounting large file systems after a crash. The
prior behavior can be restored by setting the <code
class="VARNAME">vfs.ffs.compute_summary_at_mount</code> sysctl variable to a non-zero
value.</p>

<p>A kernel panic in the NFS server has been fixed. More details can be found in errata
note <a href="ftp://ftp.FreeBSD.org/pub/FreeBSD/ERRATA/notices/FreeBSD-EN-05:01.nfs.asc"
target="_top">FreeBSD-EN-05:01.nfs</a>.</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="AEN292" name="AEN292">2.2.6 Contributed Software</a></h4>

<p><b class="APPLICATION">ACPI-CA</b> has been updated from 20040527 to 20041119.</p>
</div>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="USERLAND" name="USERLAND">2.3 Userland Changes</a></h3>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ftpd&sektion=8&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ftpd</span>(8)</span></a> program
now uses the <tt class="LITERAL">212</tt> and <tt class="LITERAL">213</tt> status codes
for directory and file status correctly (<tt class="LITERAL">211</tt> was used in the
previous versions). This behavior is described in RFC 959.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=getaddrinfo&sektion=3&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">getaddrinfo</span>(3)</span></a>
function now queries <tt class="LITERAL">A</tt> DNS resource records before <tt
class="LITERAL">AAAA</tt> records when <tt class="LITERAL">AF_UNSPEC</tt> is specified.
Some broken DNS servers return <tt class="LITERAL">NXDOMAIN</tt> against non-existent <tt
class="LITERAL">AAAA</tt> queries, even when it should return <tt
class="LITERAL">NOERROR</tt> with empty return records. This is a problem for an
IPv4/IPv6 dual stack node because the <tt class="LITERAL">NXDOMAIN</tt> returned by the
first query of an <tt class="LITERAL">AAAA</tt> record makes the querying server stop
attempting to resolve the <tt class="LITERAL">A</tt> record if any. Also, this behavior
has been recognized as a potential denial-of-service attack (see <a
href="http://www.kb.cert.org/vuls/id/714121"
target="_top">http://www.kb.cert.org/vuls/id/714121</a> for more details). Note that
although the query order has been changed, the returned result still includes <tt
class="LITERAL">AF_INET6</tt> records before <tt class="LITERAL">AF_INET</tt>
records.</p>

<p>The <tt class="LITERAL">create</tt> command of the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gpt&sektion=8&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gpt</span>(8)</span></a> utility
now supports a <code class="OPTION">-f</code> command-line flag to force creation of a
GPT even when there is an MBR record on a disk.</p>

<p>The gvinum(8) utility now supports <tt class="COMMAND">checkparity</tt>, <tt
class="COMMAND">rebuildparity</tt>, and <tt class="COMMAND">setstate</tt>
subcommands.</p>

<p>The <tt class="FILENAME">libarchive</tt> library (as well as the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tar&sektion=1&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tar</span>(1)</span></a> command
that uses it) now has support for reading ISO images (with optional RockRidge extensions)
and ZIP archives (with <tt class="LITERAL">deflate</tt> and <tt class="LITERAL">none</tt>
compression).</p>

<p>The <tt class="FILENAME">libgpib</tt> library has been added to give userland access
to GPIB devices (using the the pcii driver) via the <code class="FUNCTION">ib<tt
class="REPLACEABLE"><i>foo</i></tt></code> API.</p>

<p>A number of bugfixes for <tt class="FILENAME">libpthread</tt> have been merged from
HEAD.</p>

<p>A number of new functions have been implemented in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=math&sektion=3&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">math</span>(3)</span></a> library.
These include <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ceill&sektion=3&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ceill</span>(3)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=floorl&sektion=3&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">floorl</span>(3)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ilogbl&sektion=3&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ilogbl</span>(3)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fma&sektion=3&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fma</span>(3)</span></a> and
variants, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=lrint&sektion=3&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">lrint</span>(3)</span></a> and
variants, and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=lround&sektion=3&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">lround</span>(3)</span></a> and
variants.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=moused&sektion=8&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">moused</span>(8)</span></a> daemon
now supports ``virtual scrolling'', in which mouse motions made while holding down the
middle mouse button are interpreted as scrolling. This feature is enabled with the <code
class="OPTION">-V</code> flag.</p>

<p>A separate directory has been added for <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=named&sektion=8&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">named</span>(8)</span></a> dynamic
zones which is owned by the <tt class="USERNAME">bind</tt> user (for creation of the zone
journal file). For more detail, see an example dynamic zone in the sample <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=named.conf&sektion=5&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">named.conf</span>(5)</span></a>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=newfs&sektion=8&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">newfs</span>(8)</span></a> utility
now supports a <code class="OPTION">-n</code> flag to suppress the creation of a <tt
class="FILENAME">.snap</tt> directory on new file systems. This feature is intended for
use on memory or vnode file systems that will not require snapshot support.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=newfs&sektion=8&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">newfs</span>(8)</span></a> utility
now emits a warning when creating a UFS or UFS2 file system that cannot support
snapshots. This situation can occur in the case of very large file systems with small
block sizes.</p>

<p>The <tt class="LITERAL">NO_NIS</tt> compile-time knob for userland has been added. As
its name implies, enabling this <tt class="FILENAME">Makefile</tt> variable will cause
NIS support to be excluded from various programs and will cause the NIS utilities to not
be built.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ncal&sektion=1&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ncal</span>(1)</span></a> utility
now supports a <code class="OPTION">-m</code> flag to generate a calendar for a specified
month in the current year.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=periodic&sektion=8&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">periodic</span>(8)</span></a>
security output now supports the display of information about blocked packet counts from
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pf&sektion=4&manpath=FreeBSD+5.4-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">pf</span>(4)</span></a>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ppp&sektion=8&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ppp</span>(8)</span></a> program
now implements an <code class="OPTION">echo</code> parameter, which allows LCP ECHOs to
be enabled independently of LQR reports. Older versions of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ppp&sektion=8&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ppp</span>(8)</span></a> would
revert to LCP ECHO mode on negotiation failure. It is now necessary to specify <tt
class="COMMAND">enable echo</tt> to get this behavior.</p>

<p>Two bugs in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pppd&sektion=8&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pppd</span>(8)</span></a> program
have been fixed. They may result in an incorrect CBCP response, which violates the
Microsoft PPP Callback Control Protocol section 3.2.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=restore&sektion=8&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">restore</span>(8)</span></a>
utility has regained the ability to read FreeBSD version 1 dump tapes.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rm&sektion=1&manpath=FreeBSD+5.4-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">rm</span>(1)</span></a> utility now
supports an <code class="OPTION">-I</code> option that asks for confirmation (once) if
recursively removing directories or if more than 3 files are listed in the command
line.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rtld&sektion=1&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rtld</span>(1)</span></a> dynamic
linker now supports specifying library replacements via the <code
class="VARNAME">LD_LIBMAP</code> environment variable. This variable will override the
entries in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=libmap.conf&sektion=5&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">libmap.conf</span>(5)</span></a>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=strftime&sektion=3&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">strftime</span>(3)</span></a>
function now supports some GNU extensions such as <tt class="LITERAL">-</tt> (no
padding), <tt class="LITERAL">_</tt> (use space as padding), and <tt
class="LITERAL">0</tt> (zero padding).</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=syslog&sektion=3&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">syslog</span>(3)</span></a>
function is now thread-safe.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=syslogd&sektion=8&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">syslogd</span>(8)</span></a>
utility now opens an additional domain socket (<tt class="FILENAME">/var/run/logpriv</tt>
by default), with <tt class="LITERAL">0600</tt> permissions to be used by privileged
programs. This prevents privileged programs from locking when the domain sockets run out
of buffer space due to a local denial-of-service attack.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=syslogd&sektion=8&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">syslogd</span>(8)</span></a> now
supports <code class="OPTION">-S</code> option which allows to change the pathname of the
privileged socket. This is useful when you do not want the daemon to receive any messages
from the local sockets (<tt class="FILENAME">/var/run/log</tt> and <tt
class="FILENAME">/var/run/logpriv</tt> are used by default).</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=syslogd&sektion=8&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">syslogd</span>(8)</span></a>
utility now allows <tt class="LITERAL">:</tt> and <tt class="LITERAL">%</tt> characters
in the hostname specifications. These characters are used in IPv6 addresses and scope
IDs.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=systat&sektion=1&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">systat</span>(1)</span></a> <code
class="OPTION">-netstat</code> display is now IPv6-aware.</p>

<p>&#13;</p>

<p>The <code class="OPTION">-f</code> option of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tail&sektion=1&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tail</span>(1)</span></a> utility
now supports more than one file at a time.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tcpdrop&sektion=8&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tcpdrop</span>(8)</span></a>
command, which closes a selected TCP connection, has been added. It was obtained from
OpenBSD.</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=whois&sektion=1&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">whois</span>(1)</span></a> now
supports a <code class="OPTION">-k</code> flag for querying <tt
class="HOSTID">whois.krnic.net</tt> (the National Internet Development Agency of Korea),
which holds details of IP address allocations within Korea.</p>

<p>A bug, which caused the last line of configuration files such as <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hosts&sektion=5&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hosts</span>(5)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=services&sektion=5&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">services</span>(5)</span></a>, and
so on to be ignored if it did not end in a newline character, has been fixed.</p>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="RC-SCRIPTS" name="RC-SCRIPTS">2.3.1 <tt
class="FILENAME">/etc/rc.d</tt> Scripts</a></h4>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rc.conf&sektion=5&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rc.conf</span>(5)</span></a> now
supports changes of network interface names at boot time. For example:</p>

<pre class="PROGRAMLISTING">
ifconfig_fxp0_name="net0"
ifconfig_net0="inet 10.0.0.1/16"
</pre>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rc.conf&sektion=5&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rc.conf</span>(5)</span></a> now
supports the <code class="VARNAME">tmpmfs_flags</code> and <code
class="VARNAME">varmfs_flags</code> variables. These can be used to pass extra options to
the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mdmfs&sektion=8&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mdmfs</span>(8)</span></a>
utility, to customize the finer details of the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=md&sektion=4&manpath=FreeBSD+5.4-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">md</span>(4)</span></a> file system
creation, such as to turn on/off softupdates, to specify a default owner for the file
system, and so on.</p>
</div>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="CONTRIB" name="CONTRIB">2.4 Contributed Software</a></h3>

<p><b class="APPLICATION">BIND</b> has been updated from version 9.3.0 to version
9.3.1.</p>

<p><b class="APPLICATION">Heimdal</b> has been updated from 0.6.1 to 0.6.3.</p>

<p>A snapshot of <b class="APPLICATION">netcat</b> from OpenBSD as of 4 February 2005 has
been added. More information can be found in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=nc&sektion=1&manpath=FreeBSD+5.4-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">nc</span>(1)</span></a> manual
page.</p>

<p><b class="APPLICATION">OpenSSL</b> has been updated from 0.9.7d to 0.9.7e.</p>

<p><b class="APPLICATION">sendmail</b> has been updated from version 8.13.1 to version
8.13.3.</p>

<p>The timezone database has been updated from <b class="APPLICATION">tzdata2004e</b> to
<b class="APPLICATION">tzdata2004g</b>.</p>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="PORTS" name="PORTS">2.5 Ports/Packages Collection
Infrastructure</a></h3>

<p>The <tt class="FILENAME">ports/INDEX<tt class="REPLACEABLE"><i>*</i></tt></tt> files,
which kept an index of all of the entries in the ports collection, have been removed from
the CVS repository. These files were generated only infrequently, and therefore were
usually out-of-date and inaccurate. Users requiring an index file (such as for use by
programs such as <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=portupgrade&sektion=1&manpath=FreeBSD+Ports">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">portupgrade</span>(1)</span></a>)
have two alternatives for obtaining a copy:</p>

<ul>
<li>
<p>Build an index file based on the current ports tree by running <tt
class="COMMAND">make index</tt> from the top of the <tt class="FILENAME">ports/</tt>
tree.</p>
</li>

<li>
<p>Fetch an index file over the network by running <tt class="COMMAND">make
fetchindex</tt> from the top of the <tt class="FILENAME">ports/</tt> tree. This index
file will (typically) be accurate to within a day.</p>
</li>
</ul>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="RELENG" name="RELENG">2.6 Release Engineering and
Integration</a></h3>

<p>In prior FreeBSD releases, the <tt class="FILENAME">disc1</tt> CD-ROM (or ISO image)
was a bootable installation disk containing the base system, ports tree, and common
packages. The <tt class="FILENAME">disc2</tt> CD-ROM (or ISO image) was a bootable ``fix
it'' disk with a live filesystem, to be used for making emergency repairs. This layout
has now changed. For all architectures except ia64, the <tt class="FILENAME">disc1</tt>
image now contains the base system distribution files, ports tree, and the live
filesystem, making it suitable for both an initial installation and repair purposes. (On
the ia64, the live filesystem is on a separate disk due to its size.) Packages appear on
separate disks; in particular, the <tt class="FILENAME">disc2</tt> image contains
commonly packages such as desktop environments. Documents from the FreeBSD Documentation
Project also appear on <tt class="FILENAME">disc2</tt>.</p>

<p>The supported version of the <b class="APPLICATION">GNOME</b> desktop environment has
been updated from 2.6.2 to 2.10. More information about running <b
class="APPLICATION">GNOME</b> on FreeBSD can be found on the <a
href="http://www.FreeBSD.org/gnome/" target="_top">FreeBSD GNOME Project</a> Web
page.</p>

<div class="NOTE">
<blockquote class="NOTE">
<p><b>Note:</b> Users of older versions of the <b class="APPLICATION">GNOME</b> desktop
(<a href="http://www.FreeBSD.org/cgi/url.cgi?ports/x11/gnome2/pkg-descr"><tt
class="FILENAME">x11/gnome2</tt></a>) must take particular care in upgrading. Simply
upgrading it from the FreeBSD Ports Collection with <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=portupgrade&sektion=1&manpath=FreeBSD+Ports">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">portupgrade</span>(1)</span></a>
(<a href="http://www.FreeBSD.org/cgi/url.cgi?ports/sysutils/portupgrade/pkg-descr"><tt
class="FILENAME">sysutils/portupgrade</tt></a>) will cause serious problems. <b
class="APPLICATION">GNOME</b> desktop users should read the instructions carefully at <a
href="http://www.FreeBSD.org/gnome/docs/faq210.html"
target="_top">http://www.FreeBSD.org/gnome/docs/faq210.html</a> and use the <a
href="http://www.FreeBSD.org/gnome/gnome_upgrade.sh" target="_top"><tt
class="FILENAME">gnome_upgrade.sh</tt></a> script to properly upgrade to <b
class="APPLICATION">GNOME</b> 2.10.</p>
</blockquote>
</div>

<br />
<br />
<p>The supported version of the <b class="APPLICATION">KDE</b> desktop environment has
been updated from 3.3.0 to 3.4.0. More information regarding running <b
class="APPLICATION">KDE</b> on FreeBSD can be found on the <a
href="http://freebsd.kde.org/" target="_top">KDE on FreeBSD</a> Web page.</p>

<div class="NOTE">
<blockquote class="NOTE">
<p><b>Note:</b> Users of older versions of <b class="APPLICATION">KDE</b> should follow
the upgrading procedure documented on the <a href="http://freebsd.kde.org/"
target="_top">KDE on FreeBSD</a> Web page or in <tt
class="FILENAME">ports/UPDATING</tt>.</p>
</blockquote>
</div>

<br />
<br />
<p>The supported version of <b class="APPLICATION">Xorg</b> has been updated from 6.7.0
to 6.8.2.</p>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="DOC" name="DOC">2.7 Documentation</a></h3>

<p>The following manual pages, which were derived from RFCs and possibly violate the
IETF's copyrights, have been replaced: <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gai_strerror&sektion=3&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gai_strerror</span>(3)</span></a>,
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=getaddrinfo&sektion=3&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">getaddrinfo</span>(3)</span></a>,
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=getnameinfo&sektion=3&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">getnameinfo</span>(3)</span></a>,
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=inet6_opt_init&sektion=3&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">inet6_opt_init</span>(3)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=inet6_option_space&sektion=3&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">inet6_option_space</span>(3)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=inet6_rth_space&sektion=3&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">inet6_rth_space</span>(3)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=inet6_rthdr_space&sektion=3&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">inet6_rthdr_space</span>(3)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=icmp6&sektion=4&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">icmp6</span>(4)</span></a>, and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ip6&sektion=4&manpath=FreeBSD+5.4-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ip6</span>(4)</span></a>.</p>
</div>
</div>

<div class="SECT1">
<hr />
<h2 class="SECT1"><a id="UPGRADE" name="UPGRADE">3 Upgrading from previous releases of
FreeBSD</a></h2>

<p>Users with existing FreeBSD systems are <span class="emphasis"><i
class="EMPHASIS">highly</i></span> encouraged to read the ``FreeBSD 5.4-RELEASE Migration
Guide''. This document generally has the filename <tt class="FILENAME">MIGRATE5.TXT</tt>
on the distribution media, or any other place that the release notes can be found. It
offers some notes on migrating from FreeBSD 4.X, but more importantly, also discusses
some of the relative merits of upgrading to FreeBSD 5.<tt
class="REPLACEABLE"><i>X</i></tt> versus running FreeBSD 4.<tt
class="REPLACEABLE"><i>X</i></tt>.</p>

<div class="IMPORTANT">
<blockquote class="IMPORTANT">
<p><b>Important:</b> Upgrading FreeBSD should, of course, only be attempted after backing
up <span class="emphasis"><i class="EMPHASIS">all</i></span> data and configuration
files.</p>
</blockquote>
</div>
</div>
</div>

<hr />
<p align="center"><small>This file, and other release-related documents, can be
downloaded from <a href="ftp://ftp.FreeBSD.org/">ftp://ftp.FreeBSD.org/</a>.</small></p>

<p align="center"><small>For questions about FreeBSD, read the <a
href="http://www.FreeBSD.org/docs.html">documentation</a> before contacting &#60;<a
href="mailto:questions@FreeBSD.org">questions@FreeBSD.org</a>&#62;.</small></p>

<p align="center"><small>For questions about this documentation, e-mail &#60;<a
href="mailto:doc@FreeBSD.org">doc@FreeBSD.org</a>&#62;.</small></p>
++++


